=== modified file 'client/mysqlbinlog.cc'
--- client/mysqlbinlog.cc	2013-04-15 13:09:22 +0000
+++ client/mysqlbinlog.cc	2013-06-27 12:33:05 +0000
@@ -37,6 +37,7 @@
 /* That one is necessary for defines of OPTION_NO_FOREIGN_KEY_CHECKS etc */
 #include "sql_priv.h"
 #include "log_event.h"
+#include "compat56.h"
 #include "sql_common.h"
 #include "my_dir.h"
 #include <welcome_copyright_notice.h> // ORACLE_WELCOME_COPYRIGHT_NOTICE
@@ -2562,3 +2563,4 @@ void *sql_alloc(size_t size)
 #include "sql_string.cc"
 #include "sql_list.cc"
 #include "rpl_filter.cc"
+#include "compat56.cc"

=== modified file 'include/my_time.h'
--- include/my_time.h	2013-05-24 15:09:59 +0000
+++ include/my_time.h	2013-07-05 05:46:34 +0000
@@ -111,6 +111,8 @@ longlong pack_time(MYSQL_TIME *my_time);
 MYSQL_TIME *unpack_time(longlong packed, MYSQL_TIME *my_time);
 
 int check_time_range(struct st_mysql_time *my_time, uint dec, int *warning);
+my_bool check_datetime_range(const MYSQL_TIME *ltime);
+
 
 long calc_daynr(uint year,uint month,uint day);
 uint calc_days_in_year(uint year);
@@ -163,6 +165,8 @@ int my_date_to_str(const MYSQL_TIME *l_t
 int my_datetime_to_str(const MYSQL_TIME *l_time, char *to, uint digits);
 int my_TIME_to_str(const MYSQL_TIME *l_time, char *to, uint digits);
 
+int my_timeval_to_str(const struct timeval *tm, char *to, uint dec);
+
 static inline longlong sec_part_shift(longlong second_part, uint digits)
 {
   return second_part / (longlong)log_10_int[TIME_SECOND_PART_DIGITS - digits];
@@ -171,12 +175,23 @@ static inline longlong sec_part_unshift(
 {
   return second_part * (longlong)log_10_int[TIME_SECOND_PART_DIGITS - digits];
 }
-static inline ulong sec_part_truncate(ulong second_part, uint digits)
+
+/* Date/time rounding and truncation functions */
+static inline long my_time_fraction_remainder(long nr, uint decimals)
+{
+  DBUG_ASSERT(decimals <= TIME_SECOND_PART_DIGITS);
+  return nr % (long) log_10_int[TIME_SECOND_PART_DIGITS - decimals];
+}
+static inline void my_time_trunc(MYSQL_TIME *ltime, uint decimals)
+{
+  ltime->second_part-= my_time_fraction_remainder(ltime->second_part, decimals);
+}
+static inline void my_timeval_trunc(struct timeval *tv, uint decimals)
 {
-  /* the cast here should be unnecessary! */
-  return second_part - second_part % (ulong)log_10_int[TIME_SECOND_PART_DIGITS - digits];
+  tv->tv_usec-= my_time_fraction_remainder(tv->tv_usec, decimals);
 }
 
+
 #define hrtime_to_my_time(X) ((my_time_t)hrtime_to_time(X))
 
 /* 

=== modified file 'include/mysql.h.pp'
--- include/mysql.h.pp	2013-05-24 15:09:59 +0000
+++ include/mysql.h.pp	2013-06-18 10:35:35 +0000
@@ -49,6 +49,9 @@ enum enum_field_types { MYSQL_TYPE_DECIM
    MYSQL_TYPE_DATETIME, MYSQL_TYPE_YEAR,
    MYSQL_TYPE_NEWDATE, MYSQL_TYPE_VARCHAR,
    MYSQL_TYPE_BIT,
+   MYSQL_TYPE_TIMESTAMP2,
+   MYSQL_TYPE_DATETIME2,
+   MYSQL_TYPE_TIME2,
                         MYSQL_TYPE_NEWDECIMAL=246,
    MYSQL_TYPE_ENUM=247,
    MYSQL_TYPE_SET=248,

=== modified file 'include/mysql_com.h'
--- include/mysql_com.h	2013-06-06 19:32:29 +0000
+++ include/mysql_com.h	2013-07-05 05:50:37 +0000
@@ -400,6 +400,16 @@ enum enum_field_types { MYSQL_TYPE_DECIM
 			MYSQL_TYPE_DATETIME, MYSQL_TYPE_YEAR,
 			MYSQL_TYPE_NEWDATE, MYSQL_TYPE_VARCHAR,
 			MYSQL_TYPE_BIT,
+                        /*
+                          mysql-5.6 compatibility temporal types.
+                          They're only used internally for reading RBR
+                          mysql-5.6 binary log events and mysql-5.6 frm files.
+                          They're never sent to the client.
+                        */
+                        MYSQL_TYPE_TIMESTAMP2,
+                        MYSQL_TYPE_DATETIME2,
+                        MYSQL_TYPE_TIME2,
+                        
                         MYSQL_TYPE_NEWDECIMAL=246,
 			MYSQL_TYPE_ENUM=247,
 			MYSQL_TYPE_SET=248,

=== modified file 'mysql-test/r/statistics.result'
--- mysql-test/r/statistics.result	2013-04-22 09:18:46 +0000
+++ mysql-test/r/statistics.result	2013-07-02 06:53:52 +0000
@@ -220,7 +220,7 @@ db_name	table_name	column_name	min_value
 test	t1	a	0	49	0.0000	1.0000	4	SINGLE_PREC_HB	2E62A1D0
 test	t1	b	vvvvvvvvvvvvv	zzzzzzzzzzzzzzzzzz	0.2000	6.4000	4	SINGLE_PREC_HB	003FBFFF
 test	t1	c	aaaa	dddddddd	0.1250	7.0000	4	SINGLE_PREC_HB	0055AAFF
-test	t1	d	1989-03-12	1999-07-23	0.1500	8.5000	4	SINGLE_PREC_HB	009393FF
+test	t1	d	1989-03-12	1999-07-23	0.1500	8.5000	4	SINGLE_PREC_HB	001919FF
 test	t1	e	0.01	0.112	0.2250	6.2000	4	SINGLE_PREC_HB	000564E1
 test	t1	f	1	5	0.2000	6.4000	4	SINGLE_PREC_HB	3F7FBFBF
 DELETE FROM mysql.column_stats;
@@ -238,7 +238,7 @@ db_name	table_name	column_name	min_value
 test	t1	a	0	49	0.0000	1.0000	8	DOUBLE_PREC_HB	052F4363F4A1F9D0
 test	t1	b	vvvvvvvvvvvvv	zzzzzzzzzzzzzzzzzz	0.2000	6.4000	8	DOUBLE_PREC_HB	0000FF3FFFBFFFFF
 test	t1	c	aaaa	dddddddd	0.1250	7.0000	8	DOUBLE_PREC_HB	00005555AAAAFFFF
-test	t1	d	1989-03-12	1999-07-23	0.1500	8.5000	8	DOUBLE_PREC_HB	000026942694FFFF
+test	t1	d	1989-03-12	1999-07-23	0.1500	8.5000	8	DOUBLE_PREC_HB	0000031A031AFFFF
 test	t1	e	0.01	0.112	0.2250	6.2000	8	DOUBLE_PREC_HB	000005056464E1E1
 test	t1	f	1	5	0.2000	6.4000	8	DOUBLE_PREC_HB	FF3FFF7FFFBFFFBF
 DELETE FROM mysql.column_stats;

=== modified file 'mysql-test/r/strict.result'
--- mysql-test/r/strict.result	2012-04-07 13:58:46 +0000
+++ mysql-test/r/strict.result	2013-06-28 14:00:13 +0000
@@ -1135,7 +1135,7 @@ create table t1 (col1 date, col2 datetim
 insert into t1 values (0,0,0);
 ERROR 22007: Incorrect date value: '0' for column 'col1' at row 1
 insert into t1 values (0.0,0.0,0.0);
-ERROR 22007: Incorrect date value: '0' for column 'col1' at row 1
+ERROR 22007: Incorrect date value: '0.0' for column 'col1' at row 1
 insert into t1 (col1) values (convert('0000-00-00',date));
 ERROR 22007: Incorrect datetime value: '0000-00-00'
 insert into t1 (col1) values (cast('0000-00-00' as date));

=== added file 'mysql-test/r/type_temporal_mysql56.result'
--- mysql-test/r/type_temporal_mysql56.result	1970-01-01 00:00:00 +0000
+++ mysql-test/r/type_temporal_mysql56.result	2013-06-27 10:56:21 +0000
@@ -0,0 +1,89 @@
+SHOW CREATE TABLE mysql56time;
+Table	Create Table
+mysql56time	CREATE TABLE `mysql56time` (
+  `t0` time DEFAULT NULL,
+  `t1` time(1) DEFAULT NULL,
+  `t2` time(2) DEFAULT NULL,
+  `t3` time(3) DEFAULT NULL,
+  `t4` time(4) DEFAULT NULL,
+  `t5` time(5) DEFAULT NULL,
+  `t6` time(6) DEFAULT NULL
+) ENGINE=MyISAM DEFAULT CHARSET=latin1
+SELECT * FROM mysql56time;
+t0	838:59:59
+t1	838:59:59.0
+t2	838:59:59.00
+t3	838:59:59.000
+t4	838:59:59.0000
+t5	838:59:59.00000
+t6	838:59:59.000000
+t0	00:00:00
+t1	00:00:00.0
+t2	00:00:00.00
+t3	00:00:00.000
+t4	00:00:00.0000
+t5	00:00:00.00000
+t6	00:00:00.000000
+t0	-838:59:59
+t1	-838:59:59.0
+t2	-838:59:59.00
+t3	-838:59:59.000
+t4	-838:59:59.0000
+t5	-838:59:59.00000
+t6	-838:59:59.000000
+DROP TABLE mysql56time;
+SHOW CREATE TABLE mysql56datetime;
+Table	Create Table
+mysql56datetime	CREATE TABLE `mysql56datetime` (
+  `dt0` datetime DEFAULT NULL,
+  `dt1` datetime(1) DEFAULT NULL,
+  `dt2` datetime(2) DEFAULT NULL,
+  `dt3` datetime(3) DEFAULT NULL,
+  `dt4` datetime(4) DEFAULT NULL,
+  `dt5` datetime(5) DEFAULT NULL,
+  `dt6` datetime(6) DEFAULT NULL
+) ENGINE=MyISAM DEFAULT CHARSET=latin1
+SELECT * FROM mysql56datetime;
+dt0	0000-00-00 00:00:00
+dt1	0000-00-00 00:00:00.0
+dt2	0000-00-00 00:00:00.00
+dt3	0000-00-00 00:00:00.000
+dt4	0000-00-00 00:00:00.0000
+dt5	0000-00-00 00:00:00.00000
+dt6	0000-00-00 00:00:00.000000
+dt0	9999-12-31 23:59:59
+dt1	9999-12-31 23:59:59.9
+dt2	9999-12-31 23:59:59.99
+dt3	9999-12-31 23:59:59.999
+dt4	9999-12-31 23:59:59.9999
+dt5	9999-12-31 23:59:59.99999
+dt6	9999-12-31 23:59:59.999999
+DROP TABLE mysql56datetime;
+SET TIME_ZONE='+00:00';
+SHOW CREATE TABLE mysql56timestamp;
+Table	Create Table
+mysql56timestamp	CREATE TABLE `mysql56timestamp` (
+  `ts0` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
+  `ts1` timestamp(1) NOT NULL DEFAULT '0000-00-00 00:00:00.0',
+  `ts2` timestamp(2) NOT NULL DEFAULT '0000-00-00 00:00:00.00',
+  `ts3` timestamp(3) NOT NULL DEFAULT '0000-00-00 00:00:00.000',
+  `ts4` timestamp(4) NOT NULL DEFAULT '0000-00-00 00:00:00.0000',
+  `ts5` timestamp(5) NOT NULL DEFAULT '0000-00-00 00:00:00.00000',
+  `ts6` timestamp(6) NOT NULL DEFAULT '0000-00-00 00:00:00.000000'
+) ENGINE=MyISAM DEFAULT CHARSET=latin1
+SELECT * FROM mysql56timestamp;
+ts0	1970-01-01 00:00:01
+ts1	1970-01-01 00:00:01.0
+ts2	1970-01-01 00:00:01.00
+ts3	1970-01-01 00:00:01.000
+ts4	1970-01-01 00:00:01.0000
+ts5	1970-01-01 00:00:01.00000
+ts6	1970-01-01 00:00:01.000000
+ts0	2038-01-19 03:14:07
+ts1	2038-01-19 03:14:07.9
+ts2	2038-01-19 03:14:07.99
+ts3	2038-01-19 03:14:07.999
+ts4	2038-01-19 03:14:07.9999
+ts5	2038-01-19 03:14:07.99999
+ts6	2038-01-19 03:14:07.999999
+DROP TABLE mysql56timestamp;

=== modified file 'mysql-test/suite/binlog/r/binlog_mysqlbinlog_row_innodb.result'
--- mysql-test/suite/binlog/r/binlog_mysqlbinlog_row_innodb.result	2013-04-15 08:55:27 +0000
+++ mysql-test/suite/binlog/r/binlog_mysqlbinlog_row_innodb.result	2013-06-18 10:35:35 +0000
@@ -2404,7 +2404,7 @@ BEGIN
 ###   @28='1000:01:01' /* DATE meta=0 nullable=1 is_null=0 */
 ###   @29=1000-01-01 00:00:00 /* DATETIME meta=0 nullable=1 is_null=0 */
 ###   @30=75601 /* TIMESTAMP meta=0 nullable=0 is_null=0 */
-###   @31='839:12:57' /* TIME meta=0 nullable=1 is_null=0 */
+###   @31='-838:59:59' /* TIME meta=0 nullable=1 is_null=0 */
 ###   @32=1901 /* YEAR meta=0 nullable=1 is_null=0 */
 ###   @33='' /* STRING(1) meta=65025 nullable=1 is_null=0 */
 ###   @34='' /* STRING(0) meta=65024 nullable=1 is_null=0 */
@@ -2766,7 +2766,7 @@ BEGIN
 ###   @28='1000:01:01' /* DATE meta=0 nullable=1 is_null=0 */
 ###   @29=1000-01-01 00:00:00 /* DATETIME meta=0 nullable=1 is_null=0 */
 ###   @30=75601 /* TIMESTAMP meta=0 nullable=0 is_null=0 */
-###   @31='839:12:57' /* TIME meta=0 nullable=1 is_null=0 */
+###   @31='-838:59:59' /* TIME meta=0 nullable=1 is_null=0 */
 ###   @32=1901 /* YEAR meta=0 nullable=1 is_null=0 */
 ###   @33='' /* STRING(1) meta=65025 nullable=1 is_null=0 */
 ###   @34='' /* STRING(0) meta=65024 nullable=1 is_null=0 */
@@ -3019,7 +3019,7 @@ BEGIN
 ###   @28='1000:01:01' /* DATE meta=0 nullable=1 is_null=0 */
 ###   @29=1000-01-01 00:00:00 /* DATETIME meta=0 nullable=1 is_null=0 */
 ###   @30=75601 /* TIMESTAMP meta=0 nullable=0 is_null=0 */
-###   @31='839:12:57' /* TIME meta=0 nullable=1 is_null=0 */
+###   @31='-838:59:59' /* TIME meta=0 nullable=1 is_null=0 */
 ###   @32=1901 /* YEAR meta=0 nullable=1 is_null=0 */
 ###   @33='' /* STRING(1) meta=65025 nullable=1 is_null=0 */
 ###   @34='' /* STRING(0) meta=65024 nullable=1 is_null=0 */
@@ -3551,7 +3551,7 @@ BEGIN
 ###   @28='1000:01:01' /* DATE meta=0 nullable=1 is_null=0 */
 ###   @29=1000-01-01 00:00:00 /* DATETIME meta=0 nullable=1 is_null=0 */
 ###   @30=75601 /* TIMESTAMP meta=0 nullable=0 is_null=0 */
-###   @31='839:12:57' /* TIME meta=0 nullable=1 is_null=0 */
+###   @31='-838:59:59' /* TIME meta=0 nullable=1 is_null=0 */
 ###   @32=1901 /* YEAR meta=0 nullable=1 is_null=0 */
 ###   @33='' /* STRING(1) meta=65025 nullable=1 is_null=0 */
 ###   @34='' /* STRING(0) meta=65024 nullable=1 is_null=0 */

=== modified file 'mysql-test/suite/binlog/r/binlog_mysqlbinlog_row_myisam.result'
--- mysql-test/suite/binlog/r/binlog_mysqlbinlog_row_myisam.result	2013-04-15 08:55:27 +0000
+++ mysql-test/suite/binlog/r/binlog_mysqlbinlog_row_myisam.result	2013-06-18 10:35:35 +0000
@@ -2404,7 +2404,7 @@ BEGIN
 ###   @28='1000:01:01' /* DATE meta=0 nullable=1 is_null=0 */
 ###   @29=1000-01-01 00:00:00 /* DATETIME meta=0 nullable=1 is_null=0 */
 ###   @30=75601 /* TIMESTAMP meta=0 nullable=0 is_null=0 */
-###   @31='839:12:57' /* TIME meta=0 nullable=1 is_null=0 */
+###   @31='-838:59:59' /* TIME meta=0 nullable=1 is_null=0 */
 ###   @32=1901 /* YEAR meta=0 nullable=1 is_null=0 */
 ###   @33='' /* STRING(1) meta=65025 nullable=1 is_null=0 */
 ###   @34='' /* STRING(0) meta=65024 nullable=1 is_null=0 */
@@ -2773,7 +2773,7 @@ BEGIN
 ###   @28='1000:01:01' /* DATE meta=0 nullable=1 is_null=0 */
 ###   @29=1000-01-01 00:00:00 /* DATETIME meta=0 nullable=1 is_null=0 */
 ###   @30=75601 /* TIMESTAMP meta=0 nullable=0 is_null=0 */
-###   @31='839:12:57' /* TIME meta=0 nullable=1 is_null=0 */
+###   @31='-838:59:59' /* TIME meta=0 nullable=1 is_null=0 */
 ###   @32=1901 /* YEAR meta=0 nullable=1 is_null=0 */
 ###   @33='' /* STRING(1) meta=65025 nullable=1 is_null=0 */
 ###   @34='' /* STRING(0) meta=65024 nullable=1 is_null=0 */
@@ -3028,7 +3028,7 @@ BEGIN
 ###   @28='1000:01:01' /* DATE meta=0 nullable=1 is_null=0 */
 ###   @29=1000-01-01 00:00:00 /* DATETIME meta=0 nullable=1 is_null=0 */
 ###   @30=75601 /* TIMESTAMP meta=0 nullable=0 is_null=0 */
-###   @31='839:12:57' /* TIME meta=0 nullable=1 is_null=0 */
+###   @31='-838:59:59' /* TIME meta=0 nullable=1 is_null=0 */
 ###   @32=1901 /* YEAR meta=0 nullable=1 is_null=0 */
 ###   @33='' /* STRING(1) meta=65025 nullable=1 is_null=0 */
 ###   @34='' /* STRING(0) meta=65024 nullable=1 is_null=0 */
@@ -3568,7 +3568,7 @@ BEGIN
 ###   @28='1000:01:01' /* DATE meta=0 nullable=1 is_null=0 */
 ###   @29=1000-01-01 00:00:00 /* DATETIME meta=0 nullable=1 is_null=0 */
 ###   @30=75601 /* TIMESTAMP meta=0 nullable=0 is_null=0 */
-###   @31='839:12:57' /* TIME meta=0 nullable=1 is_null=0 */
+###   @31='-838:59:59' /* TIME meta=0 nullable=1 is_null=0 */
 ###   @32=1901 /* YEAR meta=0 nullable=1 is_null=0 */
 ###   @33='' /* STRING(1) meta=65025 nullable=1 is_null=0 */
 ###   @34='' /* STRING(0) meta=65024 nullable=1 is_null=0 */

=== added file 'mysql-test/suite/rpl/r/rpl_temporal_mysql56.result'
--- mysql-test/suite/rpl/r/rpl_temporal_mysql56.result	1970-01-01 00:00:00 +0000
+++ mysql-test/suite/rpl/r/rpl_temporal_mysql56.result	2013-06-27 10:57:55 +0000
@@ -0,0 +1,84 @@
+include/master-slave.inc
+[connection master]
+SET TIME_ZONE='+00:00';
+SET TIME_ZONE='+00:00';
+INSERT INTO mysql56time VALUES ('01:01:01','01:01:01.1','01:01:01.11','01:01:01.111','01:01:01.1111','01:01:01.11111','01:01:01.111111');
+INSERT INTO mysql56datetime VALUES ('2001-01-01 01:01:01','2001-01-01 01:01:01.1','2001-01-01 01:01:01.11','2001-01-01 01:01:01.111','2001-01-01 01:01:01.1111','2001-01-01 01:01:01.11111','2001-01-01 01:01:01.111111');
+INSERT INTO mysql56timestamp VALUES ('2001-01-01 01:01:01','2001-01-01 01:01:01.1','2001-01-01 01:01:01.11','2001-01-01 01:01:01.111','2001-01-01 01:01:01.1111','2001-01-01 01:01:01.11111','2001-01-01 01:01:01.111111');
+SELECT * FROM mysql56time;
+t0	838:59:59
+t1	838:59:59.0
+t2	838:59:59.00
+t3	838:59:59.000
+t4	838:59:59.0000
+t5	838:59:59.00000
+t6	838:59:59.000000
+t0	00:00:00
+t1	00:00:00.0
+t2	00:00:00.00
+t3	00:00:00.000
+t4	00:00:00.0000
+t5	00:00:00.00000
+t6	00:00:00.000000
+t0	-838:59:59
+t1	-838:59:59.0
+t2	-838:59:59.00
+t3	-838:59:59.000
+t4	-838:59:59.0000
+t5	-838:59:59.00000
+t6	-838:59:59.000000
+t0	01:01:01
+t1	01:01:01.1
+t2	01:01:01.11
+t3	01:01:01.111
+t4	01:01:01.1111
+t5	01:01:01.11111
+t6	01:01:01.111111
+SELECT * FROM mysql56datetime;
+dt0	0000-00-00 00:00:00
+dt1	0000-00-00 00:00:00.0
+dt2	0000-00-00 00:00:00.00
+dt3	0000-00-00 00:00:00.000
+dt4	0000-00-00 00:00:00.0000
+dt5	0000-00-00 00:00:00.00000
+dt6	0000-00-00 00:00:00.000000
+dt0	9999-12-31 23:59:59
+dt1	9999-12-31 23:59:59.9
+dt2	9999-12-31 23:59:59.99
+dt3	9999-12-31 23:59:59.999
+dt4	9999-12-31 23:59:59.9999
+dt5	9999-12-31 23:59:59.99999
+dt6	9999-12-31 23:59:59.999999
+dt0	2001-01-01 01:01:01
+dt1	2001-01-01 01:01:01.1
+dt2	2001-01-01 01:01:01.11
+dt3	2001-01-01 01:01:01.111
+dt4	2001-01-01 01:01:01.1111
+dt5	2001-01-01 01:01:01.11111
+dt6	2001-01-01 01:01:01.111111
+SELECT * FROM mysql56timestamp;
+ts0	1970-01-01 00:00:01
+ts1	1970-01-01 00:00:01.0
+ts2	1970-01-01 00:00:01.00
+ts3	1970-01-01 00:00:01.000
+ts4	1970-01-01 00:00:01.0000
+ts5	1970-01-01 00:00:01.00000
+ts6	1970-01-01 00:00:01.000000
+ts0	2038-01-19 03:14:07
+ts1	2038-01-19 03:14:07.9
+ts2	2038-01-19 03:14:07.99
+ts3	2038-01-19 03:14:07.999
+ts4	2038-01-19 03:14:07.9999
+ts5	2038-01-19 03:14:07.99999
+ts6	2038-01-19 03:14:07.999999
+ts0	2001-01-01 01:01:01
+ts1	2001-01-01 01:01:01.1
+ts2	2001-01-01 01:01:01.11
+ts3	2001-01-01 01:01:01.111
+ts4	2001-01-01 01:01:01.1111
+ts5	2001-01-01 01:01:01.11111
+ts6	2001-01-01 01:01:01.111111
+DROP TABLE mysql56time;
+DROP TABLE mysql56datetime;
+DROP TABLE mysql56timestamp;
+include/rpl_end.inc

=== added file 'mysql-test/suite/rpl/t/rpl_temporal_mysql56.test'
--- mysql-test/suite/rpl/t/rpl_temporal_mysql56.test	1970-01-01 00:00:00 +0000
+++ mysql-test/suite/rpl/t/rpl_temporal_mysql56.test	2013-06-27 10:57:17 +0000
@@ -0,0 +1,48 @@
+--source include/master-slave.inc
+
+connection master;
+SET TIME_ZONE='+00:00';
+let $MYSQLD_MASTER_DATADIR= `select @@datadir`;
+
+connection slave;
+SET TIME_ZONE='+00:00';
+let $MYSQLD_SLAVE_DATADIR= `select @@datadir`;
+
+--copy_file std_data/mysql56time.frm $MYSQLD_MASTER_DATADIR/test/mysql56time.frm
+--copy_file std_data/mysql56time.MYD $MYSQLD_MASTER_DATADIR/test/mysql56time.MYD
+--copy_file std_data/mysql56time.MYI $MYSQLD_MASTER_DATADIR/test/mysql56time.MYI
+--copy_file std_data/mysql56time.frm $MYSQLD_SLAVE_DATADIR/test/mysql56time.frm
+--copy_file std_data/mysql56time.MYD $MYSQLD_SLAVE_DATADIR/test/mysql56time.MYD
+--copy_file std_data/mysql56time.MYI $MYSQLD_SLAVE_DATADIR/test/mysql56time.MYI
+
+--copy_file std_data/mysql56datetime.frm $MYSQLD_MASTER_DATADIR/test/mysql56datetime.frm
+--copy_file std_data/mysql56datetime.MYD $MYSQLD_MASTER_DATADIR/test/mysql56datetime.MYD
+--copy_file std_data/mysql56datetime.MYI $MYSQLD_MASTER_DATADIR/test/mysql56datetime.MYI
+--copy_file std_data/mysql56datetime.frm $MYSQLD_SLAVE_DATADIR/test/mysql56datetime.frm
+--copy_file std_data/mysql56datetime.MYD $MYSQLD_SLAVE_DATADIR/test/mysql56datetime.MYD
+--copy_file std_data/mysql56datetime.MYI $MYSQLD_SLAVE_DATADIR/test/mysql56datetime.MYI
+
+--copy_file std_data/mysql56timestamp.frm $MYSQLD_MASTER_DATADIR/test/mysql56timestamp.frm
+--copy_file std_data/mysql56timestamp.MYD $MYSQLD_MASTER_DATADIR/test/mysql56timestamp.MYD
+--copy_file std_data/mysql56timestamp.MYI $MYSQLD_MASTER_DATADIR/test/mysql56timestamp.MYI
+--copy_file std_data/mysql56timestamp.frm $MYSQLD_SLAVE_DATADIR/test/mysql56timestamp.frm
+--copy_file std_data/mysql56timestamp.MYD $MYSQLD_SLAVE_DATADIR/test/mysql56timestamp.MYD
+--copy_file std_data/mysql56timestamp.MYI $MYSQLD_SLAVE_DATADIR/test/mysql56timestamp.MYI
+
+connection master;
+INSERT INTO mysql56time VALUES ('01:01:01','01:01:01.1','01:01:01.11','01:01:01.111','01:01:01.1111','01:01:01.11111','01:01:01.111111');
+INSERT INTO mysql56datetime VALUES ('2001-01-01 01:01:01','2001-01-01 01:01:01.1','2001-01-01 01:01:01.11','2001-01-01 01:01:01.111','2001-01-01 01:01:01.1111','2001-01-01 01:01:01.11111','2001-01-01 01:01:01.111111');
+INSERT INTO mysql56timestamp VALUES ('2001-01-01 01:01:01','2001-01-01 01:01:01.1','2001-01-01 01:01:01.11','2001-01-01 01:01:01.111','2001-01-01 01:01:01.1111','2001-01-01 01:01:01.11111','2001-01-01 01:01:01.111111');
+sync_slave_with_master;
+
+connection slave;
+--query_vertical SELECT * FROM mysql56time
+--query_vertical SELECT * FROM mysql56datetime
+--query_vertical SELECT * FROM mysql56timestamp
+
+connection master;
+DROP TABLE mysql56time;
+DROP TABLE mysql56datetime;
+DROP TABLE mysql56timestamp;
+
+--source include/rpl_end.inc

=== added file 'mysql-test/t/type_temporal_mysql56.test'
--- mysql-test/t/type_temporal_mysql56.test	1970-01-01 00:00:00 +0000
+++ mysql-test/t/type_temporal_mysql56.test	2013-06-27 10:55:55 +0000
@@ -0,0 +1,23 @@
+
+let $MYSQLD_DATADIR= `select @@datadir`;
+--copy_file std_data/mysql56time.frm $MYSQLD_DATADIR/test/mysql56time.frm
+--copy_file std_data/mysql56time.MYD $MYSQLD_DATADIR/test/mysql56time.MYD
+--copy_file std_data/mysql56time.MYI $MYSQLD_DATADIR/test/mysql56time.MYI
+SHOW CREATE TABLE mysql56time;
+--query_vertical SELECT * FROM mysql56time
+DROP TABLE mysql56time;
+
+--copy_file std_data/mysql56datetime.frm $MYSQLD_DATADIR/test/mysql56datetime.frm
+--copy_file std_data/mysql56datetime.MYD $MYSQLD_DATADIR/test/mysql56datetime.MYD
+--copy_file std_data/mysql56datetime.MYI $MYSQLD_DATADIR/test/mysql56datetime.MYI
+SHOW CREATE TABLE mysql56datetime;
+--query_vertical SELECT * FROM mysql56datetime
+DROP TABLE mysql56datetime;
+
+--copy_file std_data/mysql56timestamp.frm $MYSQLD_DATADIR/test/mysql56timestamp.frm
+--copy_file std_data/mysql56timestamp.MYD $MYSQLD_DATADIR/test/mysql56timestamp.MYD
+--copy_file std_data/mysql56timestamp.MYI $MYSQLD_DATADIR/test/mysql56timestamp.MYI
+SET TIME_ZONE='+00:00';
+SHOW CREATE TABLE mysql56timestamp;
+--query_vertical SELECT * FROM mysql56timestamp
+DROP TABLE mysql56timestamp;

=== modified file 'sql-common/my_time.c'
--- sql-common/my_time.c	2013-04-07 12:00:16 +0000
+++ sql-common/my_time.c	2013-07-05 06:02:50 +0000
@@ -203,6 +203,29 @@ static uint skip_digits(const char **str
   return s - start;
 }
 
+
+/**
+  Check datetime, date, or normalized time (i.e. time without days) range.
+  @param ltime   Datetime value.
+  @returns
+  @retval   FALSE on success
+  @retval   TRUE  on error
+*/
+my_bool check_datetime_range(const MYSQL_TIME *ltime)
+{
+  /*
+    In case of MYSQL_TIMESTAMP_TIME hour value can be up to TIME_MAX_HOUR.
+    In case of MYSQL_TIMESTAMP_DATETIME it cannot be bigger than 23.
+  */
+  return
+    ltime->year > 9999 || ltime->month > 12  || ltime->day > 31 || 
+    ltime->minute > 59 || ltime->second > 59 ||
+    ltime->second_part > TIME_MAX_SECOND_PART ||
+    (ltime->hour >
+     (ltime->time_type == MYSQL_TIMESTAMP_TIME ? TIME_MAX_HOUR : 23));
+}
+
+
 /*
   Convert a timestamp string to a MYSQL_TIME value.
 
@@ -332,9 +355,14 @@ str_to_datetime(const char *str, uint le
     uint second_part;
     const char *start= ++str;
     *was_cut= get_digits(&second_part, &number_of_fields, &str, end, 6);
-    if (str - start < 6)
-      second_part*= log_10_int[6 - (str - start)];
-    l_time->second_part= second_part;
+    if (number_of_fields == 7)
+    {
+      if (str - start < 6)
+        second_part*= log_10_int[6 - (str - start)];
+      l_time->second_part= second_part;
+    }
+    else
+      l_time->second_part= 0;
     if (skip_digits(&str, end))
       *was_cut= 1;
   }
@@ -1101,6 +1129,27 @@ int my_TIME_to_str(const MYSQL_TIME *l_t
 }
 
 
+/**
+  Print a timestamp with an optional fractional part: XXXXX[.YYYYY]
+
+  @param      tm  The timestamp value to print.
+  @param  OUT to  The string pointer to print at. 
+  @param      dec Precision, in the range 0..6.
+  @return         The length of the result string.
+*/
+int my_timeval_to_str(const struct timeval *tm, char *to, uint dec)
+{
+  char *pos= longlong10_to_str((longlong) tm->tv_sec, to, 10);
+  if (dec)
+  {
+    *pos++= '.';
+    pos= fmt_number((uint) sec_part_shift(tm->tv_usec, dec), pos, dec);
+  }
+  *pos= '\0';
+  return (int) (pos - to);
+}
+
+
 /*
   Convert datetime value specified as number to broken-down TIME
   representation and form value of DATETIME type as side-effect.

=== modified file 'sql/CMakeLists.txt'
--- sql/CMakeLists.txt	2013-06-06 19:32:29 +0000
+++ sql/CMakeLists.txt	2013-06-27 12:13:26 +0000
@@ -37,7 +37,7 @@ IF(SSL_DEFINES)
 ENDIF()
 
 SET (SQL_SOURCE
-              ../sql-common/client.c derror.cc des_key_file.cc
+              ../sql-common/client.c compat56.cc derror.cc des_key_file.cc
                discover.cc ../libmysql/errmsg.c field.cc  field_conv.cc 
                filesort_utils.cc
                filesort.cc gstream.cc sha2.cc

